//
// C++ Implementation: wkmanager
//
// Description: 
//
//
// Author: Andreas Lindenau <DL4JAL@darc.de>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include <QColorDialog>
#include <QColor>
#include <QIcon>
#include <QFileDialog>
#include <QTextStream>
#include <QFile>
#include <QDateTime>
#include <QPen>


#include "configfile.h"
#include "wkmanager.h"
#ifdef Q_WS_WIN
#include "win_modem.h"
#else
#include "lin_modem.h"
#endif
//#include "tooltipwkm.h"

//#include "tooltipodlg.h"


//#####################################################################################
// Class fuer Option
//#####################################################################################
owkmanager::owkmanager(QWidget * parent, Qt::WindowFlags f): QWidget(parent, f)
{
  this->resize(450,330);
  this->setMinimumSize(0,0);
  this->setWindowTitle(tr("Wobbelkurven-Manager","Windowstitel"));
  this->setWindowIcon(QIcon("appicon.png"));

  labelk1 = new QLabel(tr("Kurve 1","Wobbelkurvenmanager"),this);
  labelk1->setGeometry(180, 10, 60, 20);
  labelk2 = new QLabel(tr("Kurve 2","Wobbelkurvenmanager"),this);
  labelk2->setGeometry(240, 10, 60, 20);
  labelk3 = new QLabel(tr("Kurve 3","Wobbelkurvenmanager"),this);
  labelk3->setGeometry(300, 10, 60, 20);
  labelk4 = new QLabel(tr("Kurve 4","Wobbelkurvenmanager"),this);
  labelk4->setGeometry(360, 10, 60, 20);
  labelk5 = new QLabel(tr("Kurve 5","Wobbelkurvenmanager"),this);
  labelk5->setGeometry(420, 10, 60, 20);
  labelk6 = new QLabel(tr("Kurve 6","Wobbelkurvenmanager"),this);
  labelk6->setGeometry(480, 10, 60, 20);

  labelopen = new QLabel(tr("Kurve laden","Wobbelkurvenmanager"),this);
  labelopen->setGeometry(10, 45, 150, 20);
  labelopen->setAlignment(Qt::AlignRight);
  
  labelsave = new QLabel(tr("Kurve speichern","Wobbelkurvenmanager"),this);
  labelsave->setGeometry(10, 70, 150, 20);
  labelsave->setAlignment(Qt::AlignRight);
  
  labeluebernahme = new QLabel(tr("Kurve uebernehmen","Wobbelkurvenmanager"),this);
  labeluebernahme->setGeometry(10, 95, 150, 20);
  labeluebernahme->setAlignment(Qt::AlignRight);
  
  labelcolor = new QLabel(tr("Kurvenfarbe","Wobbelkurvenmanager"),this);
  labelcolor->setGeometry(10, 120, 150, 20);
  labelcolor->setAlignment(Qt::AlignRight);
  
  labelkanal = new QLabel(tr("Kanalaktivierung","Wobbelkurvenmanager"),this);
  labelkanal->setGeometry(10, 145, 150, 20);
  labelkanal->setAlignment(Qt::AlignRight);
  
  labeleinblendung = new QLabel(tr("Kurve einblenden","Wobbelkurvenmanager"),this);
  labeleinblendung->setGeometry(10, 170, 150, 20);
  labeleinblendung->setAlignment(Qt::AlignRight);
  
  open1 = new QPushButton(tr("Open","Wobbelkurvenmanager"), this);
  open1->setGeometry(180,40,60,25);
  connect(open1, SIGNAL(clicked()), SLOT(sopen1()));
  
  open2 = new QPushButton(tr("Open","Wobbelkurvenmanager"), this);
  open2->setGeometry(240,40,60,25);
  connect(open2, SIGNAL(clicked()), SLOT(sopen2()));
  
  open3 = new QPushButton(tr("Open","Wobbelkurvenmanager"), this);
  open3->setGeometry(300,40,60,25);
  connect(open3, SIGNAL(clicked()), SLOT(sopen3()));
  
  open4 = new QPushButton(tr("Open","Wobbelkurvenmanager"), this);
  open4->setGeometry(360,40,60,25);
  connect(open4, SIGNAL(clicked()), SLOT(sopen4()));

  open5 = new QPushButton(tr("Open","Wobbelkurvenmanager"), this);
  open5->setGeometry(420,40,60,25);
  connect(open5, SIGNAL(clicked()), SLOT(sopen5()));

  open6 = new QPushButton(tr("Open","Wobbelkurvenmanager"), this);
  open6->setGeometry(480,40,60,25);
  connect(open6, SIGNAL(clicked()), SLOT(sopen6()));

  save1 = new QPushButton(tr("Save","Wobbelkurvenmanager"), this);
  save1->setGeometry(180,65,60,25);
  save1->setEnabled(FALSE);
  connect(save1, SIGNAL(clicked()), SLOT(ssave1()));
  
  save2 = new QPushButton(tr("Save","Wobbelkurvenmanager"), this);
  save2->setGeometry(240,65,60,25);
  save2->setEnabled(FALSE);
  connect(save2, SIGNAL(clicked()), SLOT(ssave2()));
  
  save3 = new QPushButton(tr("Save","Wobbelkurvenmanager"), this);
  save3->setGeometry(300,65,60,25);
  save3->setEnabled(FALSE);
  connect(save3, SIGNAL(clicked()), SLOT(ssave3()));
  
  save4 = new QPushButton(tr("Save","Wobbelkurvenmanager"), this);
  save4->setGeometry(360,65,60,25);
  save4->setEnabled(FALSE);
  connect(save4, SIGNAL(clicked()), SLOT(ssave4()));

  save5 = new QPushButton(tr("Save","Wobbelkurvenmanager"), this);
  save5->setGeometry(420,65,60,25);
  save5->setEnabled(FALSE);
  connect(save5, SIGNAL(clicked()), SLOT(ssave5()));

  save6 = new QPushButton(tr("Save","Wobbelkurvenmanager"), this);
  save6->setGeometry(480,65,60,25);
  save6->setEnabled(FALSE);
  connect(save6, SIGNAL(clicked()), SLOT(ssave6()));

  uebernahme1 = new QPushButton(tr("Holen","Wobbelkurvenmanager"), this);
  uebernahme1->setGeometry(180,90,60,25);
  connect(uebernahme1, SIGNAL(clicked()), SLOT(sholen1()));
  
  uebernahme2 = new QPushButton(tr("Holen","Wobbelkurvenmanager"), this);
  uebernahme2->setGeometry(240,90,60,25);
  connect(uebernahme2, SIGNAL(clicked()), SLOT(sholen2()));
  
  uebernahme3 = new QPushButton(tr("Holen","Wobbelkurvenmanager"), this);
  uebernahme3->setGeometry(300,90,60,25);
  connect(uebernahme3, SIGNAL(clicked()), SLOT(sholen3()));
  
  uebernahme4 = new QPushButton(tr("Holen","Wobbelkurvenmanager"), this);
  uebernahme4->setGeometry(360,90,60,25);
  connect(uebernahme4, SIGNAL(clicked()), SLOT(sholen4()));

  uebernahme5 = new QPushButton(tr("Holen","Wobbelkurvenmanager"), this);
  uebernahme5->setGeometry(420,90,60,25);
  connect(uebernahme5, SIGNAL(clicked()), SLOT(sholen5()));
  
  uebernahme6 = new QPushButton(tr("Holen","Wobbelkurvenmanager"), this);
  uebernahme6->setGeometry(480,90,60,25);
  connect(uebernahme6, SIGNAL(clicked()), SLOT(sholen6()));

  color11 = new QPushButton("C1", this);
  color11->setGeometry(180,115,30,25);
  connect(color11, SIGNAL(clicked()), SLOT(scolor11()));
  color12 = new QPushButton("C2", this);
  color12->setGeometry(210,115,30,25);
  connect(color12, SIGNAL(clicked()), SLOT(scolor12()));
  
  color21 = new QPushButton("C1", this);
  color21->setGeometry(240,115,30,25);
  connect(color21, SIGNAL(clicked()), SLOT(scolor21()));
  color22 = new QPushButton("C2", this);
  color22->setGeometry(270,115,30,25);
  connect(color22, SIGNAL(clicked()), SLOT(scolor22()));
  
  color31 = new QPushButton("C1", this);
  color31->setGeometry(300,115,30,25);
  connect(color31, SIGNAL(clicked()), SLOT(scolor31()));
  color32 = new QPushButton("C2", this);
  color32->setGeometry(330,115,30,25);
  connect(color32, SIGNAL(clicked()), SLOT(scolor32()));
  
  color41 = new QPushButton("C1", this);
  color41->setGeometry(360,115,30,25);
  connect(color41, SIGNAL(clicked()), SLOT(scolor41()));
  color42 = new QPushButton("C2", this);
  color42->setGeometry(390,115,30,25);
  connect(color42, SIGNAL(clicked()), SLOT(scolor42()));
  
  color51 = new QPushButton("C1", this);
  color51->setGeometry(420,115,30,25);
  connect(color51, SIGNAL(clicked()), SLOT(scolor51()));
  color52 = new QPushButton("C2", this);
  color52->setGeometry(450,115,30,25);
  connect(color52, SIGNAL(clicked()), SLOT(scolor52()));

  color61 = new QPushButton("C1", this);
  color61->setGeometry(480,115,30,25);
  connect(color61, SIGNAL(clicked()), SLOT(scolor61()));
  color62 = new QPushButton("C2", this);
  color62->setGeometry(510,115,30,25);
  connect(color62, SIGNAL(clicked()), SLOT(scolor62()));

  checkboxk11 = new QCheckBox("1", this);
  checkboxk11->setGeometry(180,140,30,25);
  checkboxk11->setEnabled(FALSE);
  connect(checkboxk11, SIGNAL(clicked()), this, SLOT(saktivk11()));
  checkboxk12 = new QCheckBox("2", this);
  checkboxk12->setGeometry(210,140,30,25);
  checkboxk12->setEnabled(FALSE);
  connect(checkboxk12, SIGNAL(clicked()), this, SLOT(saktivk12()));
  
  checkboxk21 = new QCheckBox("1", this);
  checkboxk21->setGeometry(240,140,30,25);
  checkboxk21->setEnabled(FALSE);
  connect(checkboxk21, SIGNAL(clicked()), this, SLOT(saktivk21()));
  checkboxk22 = new QCheckBox("2", this);
  checkboxk22->setGeometry(270,140,30,25);
  checkboxk22->setEnabled(FALSE);
  connect(checkboxk22, SIGNAL(clicked()), this, SLOT(saktivk22()));
  
  checkboxk31 = new QCheckBox("1", this);
  checkboxk31->setGeometry(300,140,30,25);
  checkboxk31->setEnabled(FALSE);
  connect(checkboxk31, SIGNAL(clicked()), this, SLOT(saktivk31()));
  checkboxk32 = new QCheckBox("2", this);
  checkboxk32->setGeometry(330,140,30,25);
  checkboxk32->setEnabled(FALSE);
  connect(checkboxk32, SIGNAL(clicked()), this, SLOT(saktivk32()));
  
  checkboxk41 = new QCheckBox("1", this);
  checkboxk41->setGeometry(360,140,30,25);
  checkboxk41->setEnabled(FALSE);
  connect(checkboxk41, SIGNAL(clicked()), this, SLOT(saktivk41()));
  checkboxk42 = new QCheckBox("2", this);
  checkboxk42->setGeometry(390,140,30,25);
  checkboxk42->setEnabled(FALSE);
  connect(checkboxk42, SIGNAL(clicked()), this, SLOT(saktivk42()));
  
  checkboxk51 = new QCheckBox("1", this);
  checkboxk51->setGeometry(420,140,30,25);
  checkboxk51->setEnabled(FALSE);
  connect(checkboxk51, SIGNAL(clicked()), this, SLOT(saktivk51()));
  checkboxk52 = new QCheckBox("2", this);
  checkboxk52->setGeometry(450,140,30,25);
  checkboxk52->setEnabled(FALSE);
  connect(checkboxk52, SIGNAL(clicked()), this, SLOT(saktivk52()));

  checkboxk61 = new QCheckBox("1", this);
  checkboxk61->setGeometry(480,140,30,25);
  checkboxk61->setEnabled(FALSE);
  connect(checkboxk61, SIGNAL(clicked()), this, SLOT(saktivk61()));
  checkboxk62 = new QCheckBox("2", this);
  checkboxk62->setGeometry(510,140,30,25);
  checkboxk62->setEnabled(FALSE);
  connect(checkboxk62, SIGNAL(clicked()), this, SLOT(saktivk62()));


  aktiv1 = new QCheckBox(tr("Aktiv","Wobbelkurvenmanager"), this);
  aktiv1->setGeometry(180,165,60,25);
  aktiv1->setEnabled(FALSE);
  connect(aktiv1, SIGNAL(clicked()), this, SLOT(saktiv1()));
  
  aktiv2 = new QCheckBox(tr("Aktiv","Wobbelkurvenmanager"), this);
  aktiv2->setGeometry(240,165,60,25);
  aktiv2->setEnabled(FALSE);
  connect(aktiv2, SIGNAL(clicked()), SLOT(saktiv2()));
  
  aktiv3 = new QCheckBox(tr("Aktiv","Wobbelkurvenmanager"), this);
  aktiv3->setGeometry(300,165,60,25);
  aktiv3->setEnabled(FALSE);
  connect(aktiv3, SIGNAL(clicked()), SLOT(saktiv3()));
  
  aktiv4 = new QCheckBox(tr("Aktiv","Wobbelkurvenmanager"), this);
  aktiv4->setGeometry(360,165,60,25);
  aktiv4->setEnabled(FALSE);
  connect(aktiv4, SIGNAL(clicked()), SLOT(saktiv4()));

  aktiv5 = new QCheckBox(tr("Aktiv","Wobbelkurvenmanager"), this);
  aktiv5->setGeometry(420,165,60,25);
  aktiv5->setEnabled(FALSE);
  connect(aktiv5, SIGNAL(clicked()), SLOT(saktiv5()));

  aktiv6 = new QCheckBox(tr("Aktiv","Wobbelkurvenmanager"), this);
  aktiv6->setGeometry(480,165,60,25);
  aktiv6->setEnabled(FALSE);
  connect(aktiv6, SIGNAL(clicked()), SLOT(saktiv6()));
  
  labelkanal1 = new QLabel(tr("Kurve 1 leer","Wobbelkurvenmanager"),this);
  labelkanal1->setGeometry(10, 210, 700, 20);
  labelkanal2 = new QLabel(tr("Kurve 2 leer","Wobbelkurvenmanager"),this);
  labelkanal2->setGeometry(10, 230, 700, 20);
  labelkanal3 = new QLabel(tr("Kurve 3 leer","Wobbelkurvenmanager"),this);
  labelkanal3->setGeometry(10, 250, 700, 20);
  labelkanal4 = new QLabel(tr("Kurve 4 leer","Wobbelkurvenmanager"),this);
  labelkanal4->setGeometry(10, 270, 700, 20);
  labelkanal5 = new QLabel(tr("Kurve 5 leer","Wobbelkurvenmanager"),this);
  labelkanal5->setGeometry(10, 290, 700, 20);
  labelkanal6 = new QLabel(tr("Kurve 6 leer","Wobbelkurvenmanager"),this);
  labelkanal6->setGeometry(10, 310, 700, 20);
//  inherited widget (parent, name, modal);
};

owkmanager::~owkmanager()
{
}

void owkmanager::psetfontsize(int s)
{
  QFont font("Helvetica", s);

  labelk1->setFont(font);
  labelk4->setFont(font);
  labelk2->setFont(font);
  labelk3->setFont(font);
  labelk5->setFont(font);
  labelk6->setFont(font);

  labelopen->setFont(font);
  labelsave->setFont(font);
  labeluebernahme->setFont(font);
  labelcolor->setFont(font);
  labelkanal->setFont(font);
  labeleinblendung->setFont(font);

  open1->setFont(font);
  open2->setFont(font);
  open3->setFont(font);
  open4->setFont(font);
  open5->setFont(font);
  open6->setFont(font);

  save1->setFont(font);
  save2->setFont(font);
  save3->setFont(font);
  save4->setFont(font);
  save5->setFont(font);
  save6->setFont(font);

  uebernahme1->setFont(font);
  uebernahme2->setFont(font);
  uebernahme3->setFont(font);
  uebernahme4->setFont(font);
  uebernahme5->setFont(font);
  uebernahme6->setFont(font);

  color11->setFont(font);
  color12->setFont(font);
  color21->setFont(font);
  color22->setFont(font);
  color31->setFont(font);
  color32->setFont(font);
  color41->setFont(font);
  color42->setFont(font);
  color51->setFont(font);
  color52->setFont(font);
  color61->setFont(font);
  color62->setFont(font);

  checkboxk11->setFont(font);
  checkboxk12->setFont(font);
  checkboxk21->setFont(font);
  checkboxk22->setFont(font);
  checkboxk31->setFont(font);
  checkboxk32->setFont(font);
  checkboxk41->setFont(font);
  checkboxk42->setFont(font);
  checkboxk51->setFont(font);
  checkboxk52->setFont(font);
  checkboxk61->setFont(font);
  checkboxk62->setFont(font);

  aktiv1->setFont(font);
  aktiv2->setFont(font);
  aktiv3->setFont(font);
  aktiv4->setFont(font);
  aktiv5->setFont(font);
  aktiv6->setFont(font);

  labelkanal1->setFont(font);
  labelkanal2->setFont(font);
  labelkanal3->setFont(font);
  labelkanal4->setFont(font);
  labelkanal5->setFont(font);
  labelkanal6->setFont(font);
}


void owkmanager::tip(bool btip)
{
QString tip_open = tr(
  "<b>Laden einer Kurvendatei</B><BR>"
  "Laden einer abgespeicherten Kurve.<br> "
  "Mit dem \"aktiv\" Button kann man die<br>"
  "Kurve im Hintergrund als Grafik einblenden<br> "
  ,"tip_wkmanager");
QString tip_holen = tr(
  "<b>Holen einer Kurvendatei</B><BR>"
  "Holen der Wobbelkurve aus dem Arbeitsblatt<br> "
  "\"Wobbeln\". Mit dem \"aktiv\" Button kann<br>"
  " man die Kurve im Hintergrund als Grafik<br>"
  "einblenden<br> "
  ,"tip_wkmanager");
QString tip_wkmcolor = tr(
  "<b>Farbeinstellung</B><BR>"
  "Hiermit kann die Farbe jedes Kanales indivituell<br> "
  "eingestellt werden. Die Werte werden in der Datei<br>"
  "\"wkm.cfg\" automatisch gespeichert.<br>"
  ,"tip_wkmanager");
QString tip_save = tr(
  "<b>Speicher der Kurve</B><BR>"
  "Hiermit kann die Kurve noch nachtraeglich gespeichert<br> "
  "werden. Das Format ist gleich dem Format unter dem Menue<br>"
  "\"Kurve\" und kann ueber das Menue auch wieder eingelesen<br>"
  "werden.<br>"
  ,"tip_wkmanager");
 
  if(btip){
    open1->setToolTip(tip_open);
    open2->setToolTip(tip_open);
    open3->setToolTip(tip_open);
    open4->setToolTip(tip_open);
    open5->setToolTip(tip_open);
    open6->setToolTip(tip_open);

    uebernahme1->setToolTip(tip_holen);
    uebernahme2->setToolTip(tip_holen);
    uebernahme3->setToolTip(tip_holen);
    uebernahme4->setToolTip(tip_holen);
    uebernahme5->setToolTip(tip_holen);
    uebernahme6->setToolTip(tip_holen);

    color11->setToolTip(tip_wkmcolor);
    color12->setToolTip(tip_wkmcolor);
    color21->setToolTip(tip_wkmcolor);
    color22->setToolTip(tip_wkmcolor);
    color31->setToolTip(tip_wkmcolor);
    color32->setToolTip(tip_wkmcolor);
    color41->setToolTip(tip_wkmcolor);
    color42->setToolTip(tip_wkmcolor);
    color51->setToolTip(tip_wkmcolor);
    color52->setToolTip(tip_wkmcolor);
    color61->setToolTip(tip_wkmcolor);
    color62->setToolTip(tip_wkmcolor);

    save1->setToolTip(tip_save);
    save2->setToolTip(tip_save);
    save3->setToolTip(tip_save);
    save4->setToolTip(tip_save);
    save5->setToolTip(tip_save);
    save6->setToolTip(tip_save);

  }else{
    open1->setToolTip("");
    open2->setToolTip("");
    open3->setToolTip("");
    open4->setToolTip("");
    open5->setToolTip("");
    open6->setToolTip("");

    uebernahme1->setToolTip("");
    uebernahme2->setToolTip("");
    uebernahme3->setToolTip("");
    uebernahme4->setToolTip("");
    uebernahme5->setToolTip("");
    uebernahme6->setToolTip("");

    color11->setToolTip("");
    color12->setToolTip("");
    color21->setToolTip("");
    color22->setToolTip("");
    color31->setToolTip("");
    color32->setToolTip("");
    color41->setToolTip("");
    color42->setToolTip("");
    color51->setToolTip("");
    color52->setToolTip("");
    color61->setToolTip("");
    color62->setToolTip("");

    save1->setToolTip("");
    save2->setToolTip("");
    save3->setToolTip("");
    save4->setToolTip("");
    save5->setToolTip("");
    save6->setToolTip("");

  }
}

void owkmanager::beenden()
{
  QColor pencolor;
  int r,g,b,a;
  
  configfile *nwtconfigfile = new configfile();
  nwtconfigfile->open(homedir.filePath("wkm.cfg"));

  pencolor = wobbeldaten1.penkanal1.color();
  pencolor.getRgb(&r, &g, &b, &a);
  nwtconfigfile->writeInteger("wkm11r", r);
  nwtconfigfile->writeInteger("wkm11g", g);
  nwtconfigfile->writeInteger("wkm11b", b);
  nwtconfigfile->writeInteger("wkm11a", a);
  pencolor = wobbeldaten1.penkanal2.color();
  pencolor.getRgb(&r, &g, &b, &a);
  nwtconfigfile->writeInteger("wkm12r", r);
  nwtconfigfile->writeInteger("wkm12g", g);
  nwtconfigfile->writeInteger("wkm12b", b);
  nwtconfigfile->writeInteger("wkm12a", a);
  
  pencolor = wobbeldaten2.penkanal1.color();
  pencolor.getRgb(&r, &g, &b, &a);
  nwtconfigfile->writeInteger("wkm21r", r);
  nwtconfigfile->writeInteger("wkm21g", g);
  nwtconfigfile->writeInteger("wkm21b", b);
  nwtconfigfile->writeInteger("wkm21a", a);
  pencolor = wobbeldaten2.penkanal2.color();
  pencolor.getRgb(&r, &g, &b, &a);
  nwtconfigfile->writeInteger("wkm22r", r);
  nwtconfigfile->writeInteger("wkm22g", g);
  nwtconfigfile->writeInteger("wkm22b", b);
  nwtconfigfile->writeInteger("wkm22a", a);
  
  pencolor = wobbeldaten3.penkanal1.color();
  pencolor.getRgb(&r, &g, &b, &a);
  nwtconfigfile->writeInteger("wkm31r", r);
  nwtconfigfile->writeInteger("wkm31g", g);
  nwtconfigfile->writeInteger("wkm31b", b);
  nwtconfigfile->writeInteger("wkm31a", a);
  pencolor = wobbeldaten3.penkanal2.color();
  pencolor.getRgb(&r, &g, &b, &a);
  nwtconfigfile->writeInteger("wkm32r", r);
  nwtconfigfile->writeInteger("wkm32g", g);
  nwtconfigfile->writeInteger("wkm32b", b);
  nwtconfigfile->writeInteger("wkm32a", a);
  
  pencolor = wobbeldaten4.penkanal1.color();
  pencolor.getRgb(&r, &g, &b, &a);
  nwtconfigfile->writeInteger("wkm41r", r);
  nwtconfigfile->writeInteger("wkm41g", g);
  nwtconfigfile->writeInteger("wkm41b", b);
  nwtconfigfile->writeInteger("wkm41a", a);
  pencolor = wobbeldaten4.penkanal2.color();
  pencolor.getRgb(&r, &g, &b, &a);
  nwtconfigfile->writeInteger("wkm42r", r);
  nwtconfigfile->writeInteger("wkm42g", g);
  nwtconfigfile->writeInteger("wkm42b", b);
  nwtconfigfile->writeInteger("wkm42a", a);

  pencolor = wobbeldaten5.penkanal1.color();
  pencolor.getRgb(&r, &g, &b, &a);
  nwtconfigfile->writeInteger("wkm51r", r);
  nwtconfigfile->writeInteger("wkm51g", g);
  nwtconfigfile->writeInteger("wkm51b", b);
  nwtconfigfile->writeInteger("wkm51a", a);
  pencolor = wobbeldaten5.penkanal2.color();
  pencolor.getRgb(&r, &g, &b, &a);
  nwtconfigfile->writeInteger("wkm52r", r);
  nwtconfigfile->writeInteger("wkm52g", g);
  nwtconfigfile->writeInteger("wkm52b", b);
  nwtconfigfile->writeInteger("wkm2a", a);

  pencolor = wobbeldaten6.penkanal1.color();
  pencolor.getRgb(&r, &g, &b, &a);
  nwtconfigfile->writeInteger("wkm61r", r);
  nwtconfigfile->writeInteger("wkm61g", g);
  nwtconfigfile->writeInteger("wkm61b", b);
  nwtconfigfile->writeInteger("wkm61a", a);
  pencolor = wobbeldaten6.penkanal2.color();
  pencolor.getRgb(&r, &g, &b, &a);
  nwtconfigfile->writeInteger("wkm62r", r);
  nwtconfigfile->writeInteger("wkm62g", g);
  nwtconfigfile->writeInteger("wkm62b", b);
  nwtconfigfile->writeInteger("wkm62a", a);

  nwtconfigfile->close();
}

void owkmanager::save(int nr)
{
  QFile f;
  TWobbel w;
  
  switch(nr){
    case 1:
      w = wobbeldaten1;
      break;
    case 2:
      w = wobbeldaten2;
      break;
    case 3:
      w = wobbeldaten3;
      break;
    case 4:
      w = wobbeldaten4;
      break;
    case 5:
      w = wobbeldaten5;
      break;
    case 6:
      w = wobbeldaten6;
      break;

  }
  emit savekurve(w);
}

void owkmanager::sopen1()
{
  emit loadkurve(1);
  checkboxk11->setChecked(FALSE);
  checkboxk12->setChecked(FALSE);
  aktiv1->setChecked(FALSE);
};

void owkmanager::sopen2()
{
  emit loadkurve(2);
  checkboxk21->setChecked(wobbeldaten2.bkanal1);
  checkboxk22->setChecked(wobbeldaten2.bkanal2);
};

void owkmanager::sopen3()
{
  emit loadkurve(3);
  checkboxk31->setChecked(wobbeldaten3.bkanal1);
  checkboxk32->setChecked(wobbeldaten3.bkanal2);
};

void owkmanager::sopen4()
{
  emit loadkurve(4);
  checkboxk41->setChecked(wobbeldaten4.bkanal1);
  checkboxk42->setChecked(wobbeldaten4.bkanal2);
};

void owkmanager::sopen5()
{
  emit loadkurve(5);
  checkboxk51->setChecked(wobbeldaten5.bkanal1);
  checkboxk52->setChecked(wobbeldaten5.bkanal2);
};

void owkmanager::sopen6()
{
  emit loadkurve(6);
  checkboxk61->setChecked(wobbeldaten6.bkanal1);
  checkboxk62->setChecked(wobbeldaten6.bkanal2);
};

void owkmanager::ssave1()
{
  save(1);
};

void owkmanager::ssave2()
{
  save(2);
};

void owkmanager::ssave3()
{
  save(3);
};

void owkmanager::ssave4()
{
  save(4);
};

void owkmanager::ssave5()
{
  save(5);
};

void owkmanager::ssave6()
{
  save(6);
};

void owkmanager::sholen1()
{
  emit wkmgetwobbel(1);
};

void owkmanager::sholen2()
{
  emit wkmgetwobbel(2);
};

void owkmanager::sholen3()
{
  emit wkmgetwobbel(3);
};

void owkmanager::sholen4()
{
  emit wkmgetwobbel(4);
};

void owkmanager::sholen5()
{
  emit wkmgetwobbel(5);
};

void owkmanager::sholen6()
{
  emit wkmgetwobbel(6);
};


void owkmanager::scolor11()
{
  bool ok;
  QColor color = wobbeldaten1.penkanal1.color();
  QRgb rgb;
  rgb = color.rgb();
  //qDebug("scolor11");
  color = QColorDialog::getRgba(rgb, &ok, this);
  if(ok){
    wobbeldaten1.penkanal1.setColor(color);
    QPalette palette = color11->palette();
    palette.setColor(QPalette::ButtonText, color);
    color11->setPalette(palette);
  }
  saktiv1();
};

void owkmanager::scolor12()
{
  bool ok;
  QColor color = wobbeldaten1.penkanal2.color();
  QRgb rgb;
  rgb = color.rgb();
  //qDebug("scolor12");
  color = QColorDialog::getRgba(rgb, &ok, this);
  if(ok){
    wobbeldaten1.penkanal2.setColor(color);
    QPalette palette = color12->palette();
    palette.setColor(QPalette::ButtonText, color);
    color12->setPalette(palette);
  }
  saktiv1();
};

void owkmanager::scolor21()
{
  bool ok;
  QColor color = wobbeldaten2.penkanal1.color();
  QRgb rgb;
  rgb = color.rgb();
  //qDebug("scolor21");
  color = QColorDialog::getRgba(rgb, &ok, this);
  if(ok){
    wobbeldaten2.penkanal1.setColor(color);
    QPalette palette = color21->palette();
    palette.setColor(QPalette::ButtonText, color);
    color21->setPalette(palette);
  }
};

void owkmanager::scolor22()
{
  bool ok;
  QColor color = wobbeldaten2.penkanal2.color();
  QRgb rgb;
  rgb = color.rgb();
  //qDebug("scolor22");
  color = QColorDialog::getRgba(rgb, &ok, this);
  if(ok){
    wobbeldaten2.penkanal2.setColor(color);
    QPalette palette = color22->palette();
    palette.setColor(QPalette::ButtonText, color);
    color22->setPalette(palette);
  }
};

void owkmanager::scolor31()
{
  bool ok;
  QColor color = wobbeldaten3.penkanal1.color();
  QRgb rgb;
  rgb = color.rgb();
  //qDebug("scolor31");
  color = QColorDialog::getRgba(rgb, &ok, this);
  if(ok){
    wobbeldaten3.penkanal1.setColor(color);
    QPalette palette = color31->palette();
    palette.setColor(QPalette::ButtonText, color);
    color31->setPalette(palette);
  }
};

void owkmanager::scolor32()
{
  bool ok;
  QColor color = wobbeldaten3.penkanal2.color();
  QRgb rgb;
  rgb = color.rgb();
  //qDebug("scolor32");
  color = QColorDialog::getRgba(rgb, &ok, this);
  if(ok){
    wobbeldaten3.penkanal2.setColor(color);
    QPalette palette = color32->palette();
    palette.setColor(QPalette::ButtonText, color);
    color32->setPalette(palette);
  }
};

void owkmanager::scolor41()
{
  bool ok;
  QColor color = wobbeldaten4.penkanal1.color();
  QRgb rgb;
  rgb = color.rgb();
  //qDebug("scolor41");
  color = QColorDialog::getRgba(rgb, &ok, this);
  if(ok){
    wobbeldaten4.penkanal1.setColor(color);
    QPalette palette = color41->palette();
    palette.setColor(QPalette::ButtonText, color);
    color41->setPalette(palette);
  }
};

void owkmanager::scolor42()
{
  bool ok;
  QColor color = wobbeldaten4.penkanal2.color();
  QRgb rgb;
  rgb = color.rgb();
  //qDebug("scolor42");
  color = QColorDialog::getRgba(rgb, &ok, this);
  if(ok){
    wobbeldaten4.penkanal2.setColor(color);
    QPalette palette = color42->palette();
    palette.setColor(QPalette::ButtonText, color);
    color42->setPalette(palette);
  }
};

void owkmanager::scolor51()
{
  bool ok;
  QColor color = wobbeldaten5.penkanal1.color();
  QRgb rgb;
  rgb = color.rgb();
  //qDebug("scolor51");
  color = QColorDialog::getRgba(rgb, &ok, this);
  if(ok){
    wobbeldaten5.penkanal1.setColor(color);
    QPalette palette = color51->palette();
    palette.setColor(QPalette::ButtonText, color);
    color51->setPalette(palette);
  }
};

void owkmanager::scolor52()
{
  bool ok;
  QColor color = wobbeldaten5.penkanal2.color();
  QRgb rgb;
  rgb = color.rgb();
  //qDebug("scolor52");
  color = QColorDialog::getRgba(rgb, &ok, this);
  if(ok){
    wobbeldaten5.penkanal2.setColor(color);
    QPalette palette = color52->palette();
    palette.setColor(QPalette::ButtonText, color);
    color52->setPalette(palette);
  }
};

void owkmanager::scolor61()
{
  bool ok;
  QColor color = wobbeldaten6.penkanal1.color();
  QRgb rgb;
  rgb = color.rgb();
  //qDebug("scolor61");
  color = QColorDialog::getRgba(rgb, &ok, this);
  if(ok){
    wobbeldaten6.penkanal1.setColor(color);
    QPalette palette = color61->palette();
    palette.setColor(QPalette::ButtonText, color);
    color61->setPalette(palette);
  }
};

void owkmanager::scolor62()
{
  bool ok;
  QColor color = wobbeldaten6.penkanal2.color();
  QRgb rgb;
  rgb = color.rgb();
  //qDebug("scolor62");
  color = QColorDialog::getRgba(rgb, &ok, this);
  if(ok){
    wobbeldaten6.penkanal2.setColor(color);
    QPalette palette = color62->palette();
    palette.setColor(QPalette::ButtonText, color);
    color62->setPalette(palette);
  }
};

void owkmanager::saktiv1()
{
  if(aktiv1->isChecked()){
    wobbeldaten1.mess.daten_enable = TRUE;
  }else{
    wobbeldaten1.mess.daten_enable = FALSE;
  }
  //emit warneichkorr();
  emit wkmsendwobbel(wobbeldaten1);
};

void owkmanager::saktiv2()
{
  if(aktiv2->isChecked()){
    wobbeldaten2.mess.daten_enable = TRUE;
  }else{
    wobbeldaten2.mess.daten_enable = FALSE;
  }
  //emit warneichkorr();
  emit wkmsendwobbel(wobbeldaten2);
};

void owkmanager::saktiv3()
{
  if(aktiv3->isChecked()){
    wobbeldaten3.mess.daten_enable = TRUE;
  }else{
    wobbeldaten3.mess.daten_enable = FALSE;
  }
  //emit warneichkorr();
  emit wkmsendwobbel(wobbeldaten3);
};

void owkmanager::saktiv4()
{
  if(aktiv4->isChecked()){
    wobbeldaten4.mess.daten_enable = TRUE;
  }else{
    wobbeldaten4.mess.daten_enable = FALSE;
  }
  //emit warneichkorr();
  emit wkmsendwobbel(wobbeldaten4);
};

void owkmanager::saktiv5()
{
  if(aktiv5->isChecked()){
    wobbeldaten5.mess.daten_enable = TRUE;
  }else{
    wobbeldaten5.mess.daten_enable = FALSE;
  }
  //emit warneichkorr();
  emit wkmsendwobbel(wobbeldaten5);
};

void owkmanager::saktiv6()
{
  if(aktiv6->isChecked()){
    wobbeldaten6.mess.daten_enable = TRUE;
  }else{
    wobbeldaten6.mess.daten_enable = FALSE;
  }
  //emit warneichkorr();
  emit wkmsendwobbel(wobbeldaten6);
};

void owkmanager::suebergabe(const TWobbel &awobbel, const QString &dateiname)
{
  QPen pen1, pen2;
  QString s, sz;
  QDateTime zeit(QDateTime::currentDateTime());
  wobbeldaten = awobbel;
  //wobbeldaten.dbshift1 = 0.0;
  //wobbeldaten.dbshift2 = 0.0;
  //keine Eichkorrektur
  //wobbeldaten.beichkorrk1 = FALSE;
  //wobbeldaten.beichkorrk2 = FALSE;
  //===================
  wobbeldaten.mess.daten_enable = TRUE;
  wobbeldaten.bhintergrund = TRUE;
  //  wobbeldaten.bhintergrund = FALSE;
  //  Beschreibung
  if(dateiname.isEmpty()){
    sz = zeit.toString("dd.MM.yyyy hh:mm:ss");
  }else{
    sz = dateiname;
  }
  switch(wobbeldaten.kurvennr){
    case 1:
      pen1 = wobbeldaten1.penkanal1;
      pen2 = wobbeldaten1.penkanal2;
      wobbeldaten1 = wobbeldaten;
      wobbeldaten1.penkanal1 = pen1;
      wobbeldaten1.penkanal2 = pen2;
      s = tr("Kurve 1: ") + sz;
      labelkanal1->setText(s);
      checkboxk11->setEnabled(TRUE);
      checkboxk12->setEnabled(TRUE);
      aktiv1->setEnabled(TRUE);
      save1->setEnabled(TRUE);
      checkboxk11->setChecked(wobbeldaten.bkanal1);
      checkboxk12->setChecked(wobbeldaten.bkanal2);
      saktiv1();
    break;
    case 2:
      pen1 = wobbeldaten2.penkanal1;
      pen2 = wobbeldaten2.penkanal2;
      wobbeldaten2 = wobbeldaten;
      wobbeldaten2.penkanal1 = pen1;
      wobbeldaten2.penkanal2 = pen2;
      s = tr("Kurve 2: ") + sz;
      labelkanal2->setText(s);
      checkboxk21->setEnabled(TRUE);
      checkboxk22->setEnabled(TRUE);
      aktiv2->setEnabled(TRUE);
      save2->setEnabled(TRUE);
      checkboxk21->setChecked(wobbeldaten.bkanal1);
      checkboxk22->setChecked(wobbeldaten.bkanal2);
      saktiv2();
    break;
    case 3:
      pen1 = wobbeldaten3.penkanal1;
      pen2 = wobbeldaten3.penkanal2;
      wobbeldaten3 = wobbeldaten;
      wobbeldaten3.penkanal1 = pen1;
      wobbeldaten3.penkanal2 = pen2;
      s = tr("Kurve 3: ") + sz;
      labelkanal3->setText(s);
      checkboxk31->setEnabled(TRUE);
      checkboxk32->setEnabled(TRUE);
      aktiv3->setEnabled(TRUE);
      save3->setEnabled(TRUE);
      checkboxk31->setChecked(wobbeldaten.bkanal1);
      checkboxk32->setChecked(wobbeldaten.bkanal2);
      saktiv3();
    break;
    case 4:
      pen1 = wobbeldaten4.penkanal1;
      pen2 = wobbeldaten4.penkanal2;
      wobbeldaten4 = wobbeldaten;
      wobbeldaten4.penkanal1 = pen1;
      wobbeldaten4.penkanal2 = pen2;
      s = tr("Kurve 4: ") + sz;
      labelkanal4->setText(s);
      checkboxk41->setEnabled(TRUE);
      checkboxk42->setEnabled(TRUE);
      aktiv4->setEnabled(TRUE);
      save4->setEnabled(TRUE);
      checkboxk41->setChecked(wobbeldaten.bkanal1);
      checkboxk42->setChecked(wobbeldaten.bkanal2);
      saktiv4();
    break;
    case 5:
     pen1 = wobbeldaten5.penkanal1;
     pen2 = wobbeldaten5.penkanal2;
      wobbeldaten5 = wobbeldaten;
      wobbeldaten5.penkanal1 = pen1;
      wobbeldaten5.penkanal2 = pen2;
      s = tr("Kurve 5: ") + sz;
      labelkanal5->setText(s);
      checkboxk51->setEnabled(TRUE);
      checkboxk52->setEnabled(TRUE);
      aktiv5->setEnabled(TRUE);
      save5->setEnabled(TRUE);
      checkboxk51->setChecked(wobbeldaten.bkanal1);
      checkboxk52->setChecked(wobbeldaten.bkanal2);
      saktiv5();
    break;
    case 6:
      pen1 = wobbeldaten6.penkanal1;
      pen2 = wobbeldaten6.penkanal2;
      wobbeldaten6 = wobbeldaten;
      wobbeldaten6.penkanal1 = pen1;
      wobbeldaten6.penkanal2 = pen2;
      s = tr("Kurve 6: ") + sz;
      labelkanal6->setText(s);
      checkboxk61->setEnabled(TRUE);
      checkboxk62->setEnabled(TRUE);
      aktiv6->setEnabled(TRUE);
      save6->setEnabled(TRUE);
      checkboxk61->setChecked(wobbeldaten.bkanal1);
      checkboxk62->setChecked(wobbeldaten.bkanal2);
      saktiv6();
    break;
  }
};

void owkmanager::saktivk11()
{
  wobbeldaten1.bkanal1 = checkboxk11->isChecked();
  saktiv1();
}

void owkmanager::saktivk12()
{
  wobbeldaten1.bkanal2 = checkboxk12->isChecked();
  saktiv1();
}

void owkmanager::saktivk21()
{
  wobbeldaten2.bkanal1 = checkboxk21->isChecked();
  saktiv2();
}

void owkmanager::saktivk22()
{
  wobbeldaten2.bkanal2 = checkboxk22->isChecked();
  saktiv2();
}

void owkmanager::saktivk31()
{
  wobbeldaten3.bkanal1 = checkboxk31->isChecked();
  saktiv3();
}

void owkmanager::saktivk32()
{
  wobbeldaten3.bkanal2 = checkboxk32->isChecked();
  saktiv3();
}

void owkmanager::saktivk41()
{
  wobbeldaten4.bkanal1 = checkboxk41->isChecked();
  saktiv4();
}

void owkmanager::saktivk42()
{
  wobbeldaten4.bkanal2 = checkboxk42->isChecked();
  saktiv4();
}

void owkmanager::saktivk51()
{
  wobbeldaten5.bkanal1 = checkboxk51->isChecked();
  saktiv5();
}

void owkmanager::saktivk52()
{
  wobbeldaten5.bkanal2 = checkboxk52->isChecked();
  saktiv5();
}

void owkmanager::saktivk61()
{
  wobbeldaten6.bkanal1 = checkboxk61->isChecked();
  saktiv6();
}

void owkmanager::saktivk62()
{
  wobbeldaten6.bkanal2 = checkboxk62->isChecked();
  saktiv6();
}

/*
void owkmanager::setkdir(QString s)
{
  kurvendir.setPath(s);
}
*/
void owkmanager::setHomePath(QDir &dir)
{
  homedir = dir;
}

void owkmanager::ladenconfig()
{
  configfile nwtconfigfile;
  QColor pencolor;
  int r,g,b,a;
  QPalette palette;
  
  nwtconfigfile.open(homedir.filePath("wkm.cfg"));
  
  r = nwtconfigfile.readInteger("wkm11r", 185);
  g = nwtconfigfile.readInteger("wkm11g", 1);
  b = nwtconfigfile.readInteger("wkm11b", 185);
  a = nwtconfigfile.readInteger("wkm11a", 255);
  pencolor.setRgb(r,g,b,a);
  wobbeldaten1.penkanal1.setColor(pencolor);
  palette = color11->palette();
  palette.setColor(QPalette::ButtonText, pencolor);
  color11->setPalette(palette);
  r = nwtconfigfile.readInteger("wkm12r", 255);
  g = nwtconfigfile.readInteger("wkm12g", 2);
  b = nwtconfigfile.readInteger("wkm12b", 255);
  a = nwtconfigfile.readInteger("wkm12a", 255);
  pencolor.setRgb(r,g,b,a);
  wobbeldaten1.penkanal2.setColor(pencolor);
  palette = color12->palette();
  palette.setColor(QPalette::ButtonText, pencolor);
  color12->setPalette(palette);
  
  r = nwtconfigfile.readInteger("wkm21r", 255);
  g = nwtconfigfile.readInteger("wkm21g", 170);
  b = nwtconfigfile.readInteger("wkm21b", 0);
  a = nwtconfigfile.readInteger("wkm21a", 255);
  pencolor.setRgb(r,g,b,a);
  wobbeldaten2.penkanal1.setColor(pencolor);
  palette = color21->palette();
  palette.setColor(QPalette::ButtonText, pencolor);
  color21->setPalette(palette);
  r = nwtconfigfile.readInteger("wkm22r", 188);
  g = nwtconfigfile.readInteger("wkm22g", 125);
  b = nwtconfigfile.readInteger("wkm22b", 0);
  a = nwtconfigfile.readInteger("wkm22a", 255);
  pencolor.setRgb(r,g,b,a);
  wobbeldaten2.penkanal2.setColor(pencolor);
  palette = color22->palette();
  palette.setColor(QPalette::ButtonText, pencolor);
  color22->setPalette(palette);
  
  r = nwtconfigfile.readInteger("wkm31r", 128);
  g = nwtconfigfile.readInteger("wkm31g", 255);
  b = nwtconfigfile.readInteger("wkm31b", 0);
  a = nwtconfigfile.readInteger("wkm31a", 255);
  pencolor.setRgb(r,g,b,a);
  wobbeldaten3.penkanal1.setColor(pencolor);
  palette = color31->palette();
  palette.setColor(QPalette::ButtonText, pencolor);
  color31->setPalette(palette);
  r = nwtconfigfile.readInteger("wkm32r", 88);
  g = nwtconfigfile.readInteger("wkm32g", 177);
  b = nwtconfigfile.readInteger("wkm32b", 0);
  a = nwtconfigfile.readInteger("wkm32a", 255);
  pencolor.setRgb(r,g,b,a);
  wobbeldaten3.penkanal2.setColor(pencolor);
  palette = color32->palette();
  palette.setColor(QPalette::ButtonText, pencolor);
  color32->setPalette(palette);
  
  r = nwtconfigfile.readInteger("wkm41r", 0);
  g = nwtconfigfile.readInteger("wkm41g", 170);
  b = nwtconfigfile.readInteger("wkm41b", 255);
  a = nwtconfigfile.readInteger("wkm41a", 255);
  pencolor.setRgb(r,g,b,a);
  wobbeldaten4.penkanal1.setColor(pencolor);
  palette = color41->palette();
  palette.setColor(QPalette::ButtonText, pencolor);
  color41->setPalette(palette);
  r = nwtconfigfile.readInteger("wkm42r", 0);
  g = nwtconfigfile.readInteger("wkm42g", 99);
  b = nwtconfigfile.readInteger("wkm42b", 148);
  a = nwtconfigfile.readInteger("wkm42a", 255);
  pencolor.setRgb(r,g,b,a);
  wobbeldaten4.penkanal2.setColor(pencolor);
  palette = color42->palette();
  palette.setColor(QPalette::ButtonText, pencolor);
  color42->setPalette(palette);

  r = nwtconfigfile.readInteger("wkm51r", 128);
  g = nwtconfigfile.readInteger("wkm51g", 255);
  b = nwtconfigfile.readInteger("wkm51b", 0);
  a = nwtconfigfile.readInteger("wkm51a", 255);
  pencolor.setRgb(r,g,b,a);
  wobbeldaten5.penkanal1.setColor(pencolor);
  palette = color51->palette();
  palette.setColor(QPalette::ButtonText, pencolor);
  color51->setPalette(palette);
  r = nwtconfigfile.readInteger("wkm52r", 88);
  g = nwtconfigfile.readInteger("wkm52g", 177);
  b = nwtconfigfile.readInteger("wkm52b", 0);
  a = nwtconfigfile.readInteger("wkm52a", 255);
  pencolor.setRgb(r,g,b,a);
  wobbeldaten5.penkanal2.setColor(pencolor);
  palette = color52->palette();
  palette.setColor(QPalette::ButtonText, pencolor);
  color52->setPalette(palette);

  r = nwtconfigfile.readInteger("wkm61r", 0);
  g = nwtconfigfile.readInteger("wkm61g", 170);
  b = nwtconfigfile.readInteger("wkm61b", 255);
  a = nwtconfigfile.readInteger("wkm61a", 255);
  pencolor.setRgb(r,g,b,a);
  wobbeldaten6.penkanal1.setColor(pencolor);
  palette = color61->palette();
  palette.setColor(QPalette::ButtonText, pencolor);
  color61->setPalette(palette);
  r = nwtconfigfile.readInteger("wkm62r", 0);
  g = nwtconfigfile.readInteger("wkm62g", 99);
  b = nwtconfigfile.readInteger("wkm62b", 148);
  a = nwtconfigfile.readInteger("wkm62a", 255);
  pencolor.setRgb(r,g,b,a);
  wobbeldaten6.penkanal2.setColor(pencolor);
  palette = color62->palette();
  palette.setColor(QPalette::ButtonText, pencolor);
  color62->setPalette(palette);

  nwtconfigfile.close();
}
